



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>poj3667 Hotel</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">poj3667 Hotel</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 13:34:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>此题不难却易出错，很能考察思维的严谨性。</p>
<p>指定ll为区间内左端顶格数的连续可利用房间，rr为右端顶格数的数值，mm为区间内最长的连续可利用房间数。</p>
<p>在查询的时候，由于要返回最靠左的区间左端点，使得在该点右侧有长为l的可利用房间数。</p>
<p>那么首先有解存在当且仅当区间mm值大于等于给定长度l。</p>
<p>考虑区间左端点可能落在左区间也可能落在右区间。</p>
<p>横跨区间中点的情形特别要小心，我就是在这wa了几次。</p>
<p>http://poj.org/problem?id=3667</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 #include &lt;cstring&gt;<br />
 #include &lt;algorithm&gt;<br />
 #define lson (u &lt;&lt; 1)<br />
 #define rson (u &lt;&lt; 1 | 1)<br />
 using namespace std;<br />
 typedef __int64 LL;<br />
 const int maxn = 5e4 + ;<br />
 struct Seg{<br />
     int l, r;<br />
     int lazy;<br />
     int ll, mm, rr;//vacant rooms<br />
 }seg[maxn &lt;&lt; ];<br />
 int n, m, ans;

 void build(int u, int l, int r){<br />
     seg[u].l = l, seg[u].r = r, seg[u].lazy = ;<br />
     seg[u].mm = seg[u].ll = seg[u].rr = r - l;<br />
     if(r - l &lt; ) return;<br />
     int mid = (l + r) &gt;&gt; ;<br />
     build(lson, l, mid);<br />
     build(rson, mid, r);<br />
 }

 void push_down(int u){<br />
     if(seg[u].lazy !=  &amp;&amp; seg[u].r - seg[u].l &gt; ){<br />
         if(seg[u].lazy == -){<br />
             seg[lson].lazy = seg[rson].lazy = -;<br />
             seg[lson].mm = seg[lson].rr = seg[lson].ll = seg[lson].r - seg[lson].l;<br />
             seg[rson].mm = seg[rson].rr = seg[rson].ll = seg[rson].r - seg[rson].l;<br />
             seg[u].lazy = ;<br />
         }else if(seg[u].lazy == ){<br />
             seg[lson].lazy = seg[rson].lazy = ;<br />
             seg[lson].mm = seg[lson].rr = seg[lson].ll = ;<br />
             seg[rson].mm = seg[rson].rr = seg[rson].ll = ;<br />
             seg[u].lazy = ;<br />
         }<br />
     }<br />
 }

 void push_up(int u){<br />
     seg[u].mm = max(seg[lson].rr + seg[rson].ll, seg[lson].mm);<br />
     seg[u].mm = max(seg[u].mm, seg[rson].mm);<br />
     seg[u].ll = seg[lson].ll == seg[lson].r - seg[lson].l ? seg[lson].ll + seg[rson].ll : seg[lson].ll;<br />
     seg[u].rr = seg[rson].rr == seg[rson].r - seg[rson].l ? seg[rson].rr + seg[lson].rr : seg[rson].rr;<br />
 }

 void query(int u, int l, int r, int p){<br />
     if(seg[u].mm &lt; p || ans != -) return;<br />
     if(seg[u].ll &gt;= p){<br />
         ans = seg[u].l;<br />
         return;<br />
     }<br />
     push_down(u);<br />
     int mid = (l + r) &gt;&gt; ;<br />
     if(seg[lson].mm &gt;= p) query(lson, l, mid, p);<br />
     else if(seg[lson].rr + seg[rson].ll &gt;= p) ans = mid - seg[lson].rr;<br />
     else query(rson, mid, r, p);<br />
 }

 void update(int u, int l, int r, int L, int R, int sg){<br />
     if(l == L &amp;&amp; R == r){<br />
         if(sg == -){<br />
             seg[u].mm = seg[u].rr = seg[u].ll = r - l;<br />
             seg[u].lazy = -;<br />
         }else if(sg == ){<br />
             seg[u].mm = seg[u].rr = seg[u].ll = ;<br />
             seg[u].lazy = ;<br />
         }<br />
         return;<br />
     }<br />
     push_down(u);<br />
     int mid = (l + r) &gt;&gt; ;<br />
     if(R &lt;= mid) update(lson, l, mid, L, R, sg);<br />
     else if(L &gt;= mid) update(rson, mid, r, L, R, sg);<br />
     else{<br />
         update(lson, l, mid, L, mid, sg);<br />
         update(rson, mid, r, mid, R, sg);<br />
     }<br />
     push_up(u);<br />
 }

 int main(){<br />
     freopen("in.txt", "r", stdin);<br />
     while(~scanf("%d%d", &amp;n, &amp;m)){<br />
         build(, , n + );<br />
         for(int i = , u, v, op; i &lt; m; i++){<br />
             scanf("%d", &amp;op);<br />
             if(op == ){<br />
                 scanf("%d", &amp;u);<br />
                 ans = -;<br />
                 query(, , n + , u);<br />
                 printf("%d\n",ans == - ?  : ans);<br />
                 if(ans != -) update(, , n + , ans, ans + u, );<br />
             }else if(op == ){<br />
                 scanf("%d%d", &amp;u, &amp;v);<br />
                 update(, , n + , u, u + v, -);<br />
             }<br />
         }<br />
     }<br />
     return ;<br />
 }</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96ovov9.html">Java Web学习笔记---用GET实现搜索引擎</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96p7lv8.html">foxmail邮箱，签名中如何添加当前日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2n7klq.html">MFC CheckBox</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwmoxl8.html">sqlite数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okjnvp9.html">&lbrack;开发笔记&rsqb;-多线程异步操作如何访问HttpContext？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1jkj79.html">&lbrack;DHTML&rsqb;什么是DHTML？</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xykne8.html">Redis&lowbar;基本类型介绍和指令&lowbar;&lowbar;&lowbar;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1xrmk8.html">phpize 编译安装memcached</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd7e2dq.html">CSS强制图片大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv4mmyq.html">决策树之ID3算法实现&lpar;python&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j6r3o8.html">centos 虚拟机桥接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj73ne9.html">tomcat调优&lpar;三&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdozg49.html">mac 上安装 nvm 遇到的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj6m219.html">window下 多开redis</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvy5n38.html">Cheapest Palindrome &lbrack;POJ3280&rsqb; &lbrack;区间DP&rsqb; &lbrack;经典&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllpo66q.html">Java学习笔记（二十三）：final关键字</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lnplq.html">PHP 中文工具类，支持汉字转拼音、拼音分词、简繁互转</a>
		</li>
						<li><a href="https://www.batexi.com/a/960wxpy9.html">resure挽救笔记本系统和一些相关的操作记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25oxdvq.html">gitlab  jenkins 自动构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmjpxw9.html">&dollar;Simpson&dollar;积分入门</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9p112d9.html">Eclipse 调试 Java 程序的技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93005w9.html">java 线上问题定位工具</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdkk338.html">关于prototype</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnmn20q.html">配置suse自动化安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xr0n68.html">&lbrack;原创&rsqb;java WEB学习笔记47：Servlet 监听器简介， ServletContext&lpar;Application 对象&rpar;&comma; HttpSession &lpar;Session 对象&rpar;&comma; HttpServletRequest &lpar;request 对象&rpar; 监听器，利用listener理解 三个对象的生命周期</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1mvlj8.html">php第三方登陆</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1gk2n9.html">Android DatePickerDialog TimepickerDialog</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wdm4vq.html">《zw版&amp;&num;183&semi;delphi与halcon系列原创教程》zw版&lowbar;THOperatorSetX控件函数列表 v11中文增强版</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1grdd9.html">zw版【转发&amp;&num;183&semi;台湾nvp系列Delphi例程】HALCON FillUp1</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwdk0j38.html">【py网页】urllib&period;urlretrieve远程下载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
